unit msg_main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  System.Messaging,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation, msg_child, msg_thread1, msg_thread2, msg_thread3,
  msg_thread4, System.Diagnostics;

type
  TfrmMain = class(TForm)
    btnCreateThread: TButton;
    btnShowForm: TButton;
    btnMessage: TButton;
    lblMessageText: TLabel;
    lblDebug2: TLabel;
    btnStringMessage: TButton;
    btnTerminate: TButton;
    btnCreateThread2: TButton;
    btnTerminate2: TButton;
    btnCreateThread3: TButton;
    btnTerminate3: TButton;
    btnCreateThread4: TButton;
    btnTerminate4: TButton;
    btnThreadAction: TButton;
    procedure btnShowFormClick(Sender: TObject);
    procedure btnCreateThreadClick(Sender: TObject);
    procedure btnMessageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnStringMessageClick(Sender: TObject);
    procedure btnTerminateClick(Sender: TObject);
    procedure btnCreateThread2Click(Sender: TObject);
    procedure btnTerminate2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCreateThread3Click(Sender: TObject);
    procedure btnTerminate3Click(Sender: TObject);
    procedure btnCreateThread4Click(Sender: TObject);
    procedure btnTerminate4Click(Sender: TObject);
    procedure btnThreadActionClick(Sender: TObject);
  private
    {Private declarations}
    FMessageThread: TTestMessages;
    FMessageThread2: TTestMessages2;
    FMessageThread3: TTestMessages3;
    FMessageThread4: TTestMessages4;
    SubscriptionId: Integer;
    FMsgRegId: Integer;
    procedure _HandleMessage(MessageNo: Integer);
    procedure _HandleMessageString(const MessageText: string);
  public
    {Public declarations}
  end;

var
  frmMain: TfrmMain;

implementation
//uses
//  tbsLogger;

{$R *.fmx}

procedure TfrmMain.btnCreateThread2Click(Sender: TObject);
begin
  if FMessageThread2 = nil then
  begin
    FMessageThread2 := TTestMessages2.Create;
  end
  else
  begin
    if FMessageThread2.Finished then
    begin
      FMessageThread2.Free;
      FMessageThread2 := TTestMessages2.Create;
    end;
  end;
end;

procedure TfrmMain.btnCreateThread3Click(Sender: TObject);
begin
  if FMessageThread3 = nil then
  begin
    FMessageThread3 := TTestMessages3.Create;
  end
  else
  begin
    if FMessageThread3.Finished then
    begin
      FMessageThread3.Free;
      FMessageThread3 := TTestMessages3.Create;
    end;
  end;

end;

procedure TfrmMain.btnCreateThread4Click(Sender: TObject);
begin
  if FMessageThread4 = nil then
  begin
    FMessageThread4 := TTestMessages4.Create;
  end
  else
  begin
    if FMessageThread4.Finished then
    begin
      FMessageThread4.Free;
      FMessageThread4 := TTestMessages4.Create;
    end;
  end;

end;

procedure TfrmMain.btnCreateThreadClick(Sender: TObject);
begin
  if FMessageThread = nil then
  begin
    FMessageThread := TTestMessages.Create;
    // FMessageThread := TTestMessages.Create(False);
  end
  else
  begin
    if FMessageThread.Finished then
    begin
      FMessageThread.Free;
      FMessageThread := TTestMessages.Create;
    end;
  end;

end;

procedure TfrmMain.btnMessageClick(Sender: TObject);
var
  MessageManager: TMessageManager;
  lMessage: TMessage;
begin
  MessageManager := TMessageManager.DefaultManager;
  lMessage := TMessage<Integer>.Create(1);
  MessageManager.SendMessage(Sender, lMessage, True);
end;

procedure TfrmMain.btnShowFormClick(Sender: TObject);
begin
  frmChild.Show;

end;

procedure TfrmMain.btnStringMessageClick(Sender: TObject);
var
  MessageManager: TMessageManager;
  lMessage: TMessage;
  lStopWatch: TStopwatch;
begin
  MessageManager := TMessageManager.DefaultManager;
  lMessage := TMessage<Unicodestring>.Create('String message');
  lStopWatch := TStopWatch.StartNew;
  MessageManager.SendMessage(Sender, lMessage, True);
//  TtbsGCLogger.Send('main send string elapsed', lStopWatch.Elapsed);

end;

procedure TfrmMain.btnTerminate2Click(Sender: TObject);
begin
  if FMessageThread2 <> nil then
  begin
    FMessageThread2.Terminate;
  end;

end;

procedure TfrmMain.btnTerminate3Click(Sender: TObject);
begin
  if FMessageThread3 <> nil then
  begin
    FMessageThread3.Terminate;
  end;

end;

procedure TfrmMain.btnTerminate4Click(Sender: TObject);
begin
  if FMessageThread4 <> nil then
  begin
    FMessageThread4.Terminate;
  end;

end;

procedure TfrmMain.btnTerminateClick(Sender: TObject);
begin
  if FMessageThread <> nil then
  begin
    FMessageThread.Terminate;
  end;
end;

procedure TfrmMain.btnThreadActionClick(Sender: TObject);
var
  lStopWatch: TStopwatch;
begin
//  TtbsGCLogger.Send('send message start', 3);
  lStopWatch := TStopWatch.StartNew;
  TThread.CreateAnonymousThread(

procedure()
var
  MessageManager: TMessageManager;
  lMessage: TMessage;
begin
//  TtbsGCLogger.Send('send anon thr message', 3);

  MessageManager := TMessageManager.DefaultManager;
  lMessage := TMessage<UnicodeString>.Create('From anonymous thread');
  MessageManager.SendMessage(Sender, lMessage, True);
//  TtbsGCLogger.Send('sent anon thr message', 3);

end).Start;
//  TtbsGCLogger.Send('btn click anon thr elapsed', lStopWatch.Elapsed);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  MessageManager: TMessageManager;
begin
  MessageManager := TMessageManager.DefaultManager;

  // subscribe to integer message
  SubscriptionId := MessageManager.SubscribeToMessage(TMessage<Integer > ,
    procedure(const Sender: TObject; const M: TMessage)
    begin
      _HandleMessage((M as TMessage<Integer>).Value);
    end);

  // subscribe to string message
  FMsgRegId := MessageManager.SubscribeToMessage(TMessage<Unicodestring > ,
    procedure(const Sender: TObject; const Msg: TMessage)
  var
    sMsg: string;
    begin
      sMsg := (Msg as TMessage<Unicodestring>).Value;
      _HandleMessageString(sMsg);
    end);

end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
  MessageManager: TMessageManager;
begin
  MessageManager := TMessageManager.DefaultManager;
  MessageManager.Unsubscribe(TMessage<UnicodeString > , FMsgRegId);
  MessageManager.Unsubscribe(TMessage<Integer > , SubscriptionId);

  if FMessageThread <> nil then
  begin
    if not FMessageThread.Finished then
    begin
      FMessageThread.Terminate;
    end;
  end;
  if FMessageThread2 <> nil then
  begin
    if not FMessageThread2.Finished then
    begin
      FMessageThread2.Terminate;
    end;
  end;
  if FMessageThread3 <> nil then
  begin
    if not FMessageThread3.Finished then
    begin
      FMessageThread3.Terminate;
    end;
  end;
  if FMessageThread4 <> nil then
  begin
    if not FMessageThread4.Finished then
    begin
      FMessageThread4.Terminate;
    end;
  end;
  if FMessageThread <> nil then
  begin
    if not FMessageThread.Finished then
    begin
      FMessageThread.WaitFor;
    end;
  end;
  if FMessageThread2 <> nil then
  begin
    if not FMessageThread2.Finished then
      FMessageThread2.WaitFor;
  end;
  if FMessageThread3 <> nil then
  begin
    if not FMessageThread3.Finished then
      FMessageThread3.WaitFor;
  end;
  if FMessageThread4 <> nil then
  begin
    if not FMessageThread4.Finished then
      FMessageThread4.WaitFor;
  end;
end;

procedure TfrmMain._HandleMessage(MessageNo: Integer);
begin
  TThread.Synchronize(TThread.CurrentThread,
    procedure()
    begin
      lblMessageText.Text := 'Received ' + MessageNo.ToString;
    end);

end;

procedure TfrmMain._HandleMessageString(const MessageText: string);
begin
  TThread.Synchronize(TThread.CurrentThread,
    procedure()
    begin
      lblDebug2.Text := MessageText;
//      TtbsGCLogger.Send('_HandleMessageString', MessageText);
    end);

end;

end.

