unit msg_structures;

interface
uses
  System.SysUtils,
  System.Messaging;

type
  TToThreadInteger = Integer;// class(TMessage<Integer>); //
  TFromThreadInteger = Integer;// class(TMessage<Integer>); //

type
  TMyToThreadMessage = class(TMessage)
  protected
    FValue: Integer;
  public
    constructor Create(const AValue: Integer);
    destructor Destroy; override;
    property Value: Integer read FValue;
  end;

type
  TMyFromThreadMessage = class(TMessage)
  protected
    FValue: Integer;
  public
    constructor Create(const AValue: Integer);
    destructor Destroy; override;
    property Value: Integer read FValue;
  end;

type
  TMyBytesMessage = class(TMessage)
  protected
    FValue: TBytes;
  public
    constructor Create(const AValue: TBytes);
    destructor Destroy; override;
    property Value: TBytes read FValue;
  end;

type
  TMyRecord = record
    ControllerNo: Int64;
    PanelNo: Word;
    GroupID: Byte;
    BlockNo: Byte;
    ElementNo: Cardinal;
    BinaryData: TBytes;
  end;

type
  TMyRecordMessage = class(TMessage)
  protected
    FValue: TMyRecord;
  public
    constructor Create(const AValue: TMyRecord);
    destructor Destroy; override;
    property Value: TMyRecord read FValue;
  end;

function DisplayMessageManager: TMessageManager;

implementation

var
  LDisplayMessageManager: TMessageManager = nil;

function DisplayMessageManager: TMessageManager;
begin
  if not Assigned(LDisplayMessageManager) then
  begin
    LDisplayMessageManager := TMessageManager.Create;
  end;
  Result := LDisplayMessageManager;
end;


{ TMyToThreadMessage }

constructor TMyToThreadMessage.Create(const AValue: Integer);
begin
  FValue := AValue;
end;

destructor TMyToThreadMessage.Destroy;
begin

  inherited;
end;

{ TMyFromThreadMessage }

constructor TMyFromThreadMessage.Create(const AValue: Integer);
begin
  FValue := AValue;

end;

destructor TMyFromThreadMessage.Destroy;
begin

  inherited;
end;

{ TMyRecordMessage }

constructor TMyRecordMessage.Create(const AValue: TMyRecord);
begin
  FValue := Value;
end;

destructor TMyRecordMessage.Destroy;
begin

  inherited;
end;

{ TMyBytesMessage }

constructor TMyBytesMessage.Create(const AValue: TBytes);
begin
  FValue := AValue;
end;

destructor TMyBytesMessage.Destroy;
begin
  SetLength(FValue, 0);
  inherited;
end;

initialization

finalization
  LDisplayMessageManager.Free;

end.
