unit msg_thread3;

interface

uses
  System.Classes, System.Messaging, System.SysUtils, System.DateUtils,
  System.SyncObjs, System.Generics.Collections, msg_structures;

type
  TTestMessages3 = class(TThread)
  private
    FMessageManager: TMessageManager;
    FMsgRegId: Integer;
    FThreadQueue: TThreadedQueue<Integer>;
    {Private declarations}
  protected
    procedure Execute; override;
  public

  end;

implementation

//uses
//  tbsLogger;
{TTestMessages}

procedure TTestMessages3.Execute;
var
  iCount: Integer;
  lMessage: TMessage;
  dtStart: TDateTime;
  iMillis: Int64;
  iNumber: Integer;
  iPopResult: TWaitResult;
  iQueSize: Integer;
begin
  {Place thread code here}
  FMessageManager := TMessageManager.DefaultManager;
  FThreadQueue := TThreadedQueue<Integer>.Create(5, 0, 0);
  FMsgRegId := FMessageManager.SubscribeToMessage(TMessage<TToThreadInteger>,
    procedure(const Sender: TObject; const Msg: TMessage)
    var
      sMsg: string;
      lMsg: TToThreadInteger;
      iValue: Integer;
      iResultCode: TWaitResult;
    begin
      if Sender <> Self then
      begin
      iValue := (Msg as TMessage<TToThreadInteger>).Value;
      iResultCode := FThreadQueue.PushItem(iValue);
      //TtbsGCLogger.Send('3 pushed', iValue);
      end;
    end);

  iCount := 0;
  while not Terminated do
  begin
    inc(iCount);
    iPopResult := FThreadQueue.PopItem(iQueSize, iNumber);
//    TtbsGCLogger.Send('3 Thread number pop result', Integer(iPopResult));
//    TtbsGCLogger.Send('3 Thread queue size', iQueSize);
    if iPopResult = wrSignaled then
    begin
//      TtbsGCLogger.Send('3 Thread send number', iNumber.ToString);
      lMessage := TMessage<TFromThreadInteger>.Create(iNumber);
      dtStart := Now;
      TThread.CreateAnonymousThread(

        procedure()
        begin
          FMessageManager.SendMessage(Self, lMessage, True);

        end).Start;

      iMillis := MilliSecondsBetween(dtStart, Now);
      //TtbsGCLogger.Send('3 send ms', iMillis);
      // lSendMsg := FSendList.GetMessage();
    end;
    Sleep(200);
  end;
  FMessageManager.Unsubscribe(TMessage<TToThreadInteger>, FMsgRegId);

end;

end.
