unit msg_thread4;

interface

uses
  System.Classes, System.Messaging, System.SysUtils, System.DateUtils,
  System.SyncObjs, System.Generics.Collections, msg_structures;

type
  TTestMessages4 = class(TThread)
  private
    FMessageManager: TMessageManager;
    FMsgRegId: Integer;
    FThreadQueue: TThreadedQueue<Integer>;
    {Private declarations}
  protected
    procedure Execute; override;
  public

  end;

implementation

//uses
//  tbsLogger;
{TTestMessages}

procedure TTestMessages4.Execute;
var
  iCount: Integer;
  lMessage: TMessage;
  dtStart: TDateTime;
  iMillis: Int64;
  iNumber: Integer;
  iPopResult: TWaitResult;
  iQueSize: Integer;
  lMsgValue: TMyFromThreadMessage;
begin
  {Place thread code here}
  FMessageManager := TMessageManager.DefaultManager;
  FThreadQueue := TThreadedQueue<Integer>.Create(5, 0, 0);
  FMsgRegId := FMessageManager.SubscribeToMessage(TMessage<TMyToThreadMessage>,
    procedure(const Sender: TObject; const Msg: TMessage)
    var
      sMsg: string;
      iValue: Integer;
      lMsgValue: TMyToThreadMessage;
      iResultCode: TWaitResult;
    begin
      lMsgValue := (Msg as TMessage<TMyToThreadMessage>).Value;
      iResultCode := FThreadQueue.PushItem(lMsgValue.Value);
     // TtbsGCLogger.Send('4 pushed', lMsgValue.Value);
    end);

  iCount := 0;
  while not Terminated do
  begin
    inc(iCount);
    iPopResult := FThreadQueue.PopItem(iQueSize, iNumber);
//    TtbsGCLogger.Send('4 Thread number pop result', Integer(iPopResult));
//    TtbsGCLogger.Send('3 Thread queue size', iQueSize);
//    TtbsGCLogger.Send('3 Thread number', iNumber.ToString);
    if iPopResult = wrSignaled then
    begin
      //TtbsGCLogger.Send('4 Thread send number', iNumber.ToString);
      lMsgValue := TMyFromThreadMessage.Create(iNumber);
      lMessage := TMessage<TMyFromThreadMessage>.Create(lMsgValue);
      dtStart := Now;
      TThread.CreateAnonymousThread(

        procedure()
        begin
          FMessageManager.SendMessage(Self, lMessage, True);

        end).Start;

      iMillis := MilliSecondsBetween(dtStart, Now);
      //TtbsGCLogger.Send('4 send ms', iMillis);
    end;
    Sleep(200);
  end;
  FMessageManager.Unsubscribe(TMessage<TMyToThreadMessage>, FMsgRegId);

end;

end.
